<?xml version='1.0' encoding='UTF-8' ?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core"
>

<h:head>
	<ui:include src="/WEB-INF/jsf/include/title.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/imports.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/init.xhtml"/>
</h:head>
<h:outputScript>

	$(function () {
		jsf.ajax.addOnEvent(function (event) {
			if (event.status === 'success') {
			}
		});
	});

</h:outputScript>
<h:body styleClass="pushable">
	<div class="pusher">
		<div class="ui container framed">
			<ui:include src="/WEB-INF/jsf/include/header.xhtml"/>

			<div class="ui centered two columns footer-margin grid">
				<div class="ui thirteen wide column">
					<div class="ui raised segment">
						<h1>Edit spam filter</h1>
						<div class="ui divider"></div>
						<h2>Expression checker</h2>
						<h:form id="expressionCheckerFormId" styleClass="ui ${errorUtils.formClass(component)} form">
							<div class="field">
								<label>Expression</label>
								<h:inputTextarea validatorMessage="This is spam"
												 validator="#{spamValidator.validate}">
									<f:passThroughAttribute name="placeholder"
															value="An expression to check spam detection"/>
								</h:inputTextarea>
							</div>
							<div class="ui error message">
								<h:messages showDetail="true" showSummary="false"/>
							</div>
							<div class="ui success message">
								<ul>
									<li>This is not spam</li>
								</ul>
							</div>
							<h:commandButton styleClass="ui primary button" value="Check">
								<f:ajax execute="@form" render=":expressionCheckerFormId"/>
							</h:commandButton>
							<div class="ui divider"></div>
						</h:form>
						<h2>Spam patterns</h2>
						<h:form id="spamPatternsFormId" class="ui form">
							<div class="field">
								<label>New</label>
								<h:inputText value="#{newSpamPatternValue}">
									<f:passThroughAttribute name="placeholder" value="A new spam pattern value"/>
								</h:inputText>
							</div>
							<h:commandButton styleClass="ui button" value="Create" action="#{spamFilterEditBean.addSpamPattern(newSpamPatternValue)}">
								<f:ajax execute="@form" render=":spamPatternsFormId"/>
							</h:commandButton>
							<div class="ui relaxed divided list">
								<ui:repeat value="${spamFilterEditBean.spamPatterns}" var="pattern">
									<div class="item">
										<h:commandButton styleClass="ui small right floated red button"
														 value="Delete"
														 action="#{spamFilterEditBean.deleteSpamPattern(pattern)}">
											<f:ajax execute="@form" render=":spamPatternsFormId"/>
										</h:commandButton>
										<div class="content">
											<h2 class="header">
												${pattern}
											</h2>
										</div>
									</div>
								</ui:repeat>
							</div>
							<div class="ui divider"></div>
						</h:form>
						<h2>Exclude patterns</h2>
						<h:form id="spamExcludePatternsFormId" class="ui form">
							<div class="field">
								<label>New</label>
								<h:inputText value="#{newExcludePatternValue}">
									<f:passThroughAttribute name="placeholder" value="A new exclude pattern value"/>
								</h:inputText>
							</div>
							<h:commandButton styleClass="ui button" value="Create" action="#{spamFilterEditBean.addExcludePattern(newExcludePatternValue)}">
								<f:ajax execute="@form" render=":spamExcludePatternsFormId"/>
							</h:commandButton>
							<div class="ui relaxed divided list">
								<ui:repeat value="${spamFilterEditBean.excludePatterns}" var="pattern">
									<div class="item">
										<h:commandButton styleClass="ui small right floated red button"
														 value="Delete"
														 action="#{spamFilterEditBean.deleteExcludePattern(pattern)}">
											<f:ajax execute="@form" render=":spamExcludePatternsFormId"/>
										</h:commandButton>
										<div class="content">
											<h2 class="header">
												${pattern}
											</h2>
										</div>
									</div>
								</ui:repeat>
							</div>
							<div class="ui divider"></div>
						</h:form>
					</div>
				</div>
			</div>
			<p/>
			<p/>
		</div>
		<ui:include src="/WEB-INF/jsf/include/footer.xhtml"/>
	</div>
</h:body>
</html>

